﻿--declare @custType varchar(1) = 'C'
--declare @custYear int = 2005

select
    isnull(UDIC_VendorRegion.CustName, '(none)') as Region,
	isnull(UDIC_VendorRegion.CustDescription, '(none)') as RegionDescription,
	isnull(UDIC_VendorRegion.CustSortOrder, 0) as RegionSortOrder,
    /***GROUP COLUMNS***/
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 1 
        then LedgerAP.Amount 
        else 0 end) as month01,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 2 
        then LedgerAP.Amount 
        else 0 end) as month02,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 3 
        then LedgerAP.Amount 
        else 0 end) as month03,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 4 
        then LedgerAP.Amount 
        else 0 end) as month04,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 5 
        then LedgerAP.Amount 
        else 0 end) as month05,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 6 
        then LedgerAP.Amount 
        else 0 end) as month06,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 7 
        then LedgerAP.Amount 
        else 0 end) as month07,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 8 
        then LedgerAP.Amount 
        else 0 end) as month08,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 9 
        then LedgerAP.Amount 
        else 0 end) as month09,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 10 
        then LedgerAP.Amount 
        else 0 end) as month10,
    sum(case when (
			case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 11 
        then LedgerAP.Amount 
        else 0 end) as month11,
    sum(case 
			when (case when @CustType = 'F' 
			then cast(LedgerAP.Period % 100 as int) 
			else month(LedgerAP.TransDate) end) = 12 
        then LedgerAP.Amount 
        else 0 end) as month12,
    sum(LedgerAP.Amount) as total
from
    VE
    join VendorCustomTabFields on VE.Vendor = VendorCustomTabFields.Vendor
    /*add financial information*/
    left join LedgerAP on VE.Vendor = LedgerAP.Vendor
    /*add our custom region definition to the query*/
    left join UDIC_VendorRegion on VendorCustomTabFields.CustVendorRegion = UDIC_VendorRegion.UDIC_UID
    /***GROUP JOIN***/
where
	LedgerAP.TransType in ('AP', 'CV') and
	/*check for fiscal or calendar year*/
	case when @CustType = 'F' then cast(LedgerAP.Period / 100 as int) else year(LedgerAP.TransDate) end = @CustYear 
	/***EXTEND WHERE CLAUSE***/
group by 
    /***EXTEND GROUP CLAUSE***/
	isnull(UDIC_VendorRegion.CustName, '(none)') ,
	isnull(UDIC_VendorRegion.CustDescription, '(none)') ,
	isnull(UDIC_VendorRegion.CustSortOrder, 0) 
order by 
    /***EXTEND ORDER CLAUSE***/
	isnull(UDIC_VendorRegion.CustSortOrder, 0),
	isnull(UDIC_VendorRegion.CustDescription, '(none)')